﻿
SLASH_RSP1 = "/rsp";
SlashCmdList["RSP"] = function(msg)

	if string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_HideNames_Cmd))) == FlagRSP_Locale_HideNames_Cmd then
		FlagRSP:toggleHideNames();
        -- FlagRSP:UpdateTooltip();
	elseif string.lower(string.sub(msg, 1, 4)) == "stat" then
		FlagRSP:PlotStats();
	elseif string.lower(string.sub(msg, 1, 7)) == "welcome" then
		FlagRSP:showWelcomeBox();
	elseif string.lower(string.sub(msg, 1, 4)) == "tips" then
		FlagRSP:showDYKBox();
	elseif string.lower(msg) == "standby" then -- TODO Rework
        FlagRSPStatic:PrintM("Standby out of order, sorry!");
		-- if FlagRSPConfigure:GetStandby() then
			-- FlagRSPStatic:PrintM(FlagRSP_Locale_NoStandBy);
			-- FlagRSPConfigure:SetStandby(false);
			-- FlagRSP.standby = false;
		-- else
			-- FlagRSPStatic:PrintM(FlagRSP_Locale_StandBy);
			-- FlagRSPStatic:PrintM(FlagRSP_Locale_StandBy2);
			-- FlagRSP_LeaveChannel();
			-- FlagRSPConfigure:SetStandby(true);
			-- FlagRSP.standby = true;
		-- end
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_LevelDisp_Cmd))) == FlagRSP_Locale_LevelDisp_Cmd then
		FlagRSP:toggleLevelDisp();
        -- FlagRSP:UpdateTooltip();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_RankDisp_Cmd))) == FlagRSP_Locale_RankDisp_Cmd then
		FlagRSP:toggleRankDisp();
        -- FlagRSP:UpdateTooltip();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_GuildDisp_Cmd))) == FlagRSP_Locale_GuildDisp_Cmd then
		FlagRSP:toggleGuildDisp();
        -- FlagRSP:UpdateTooltip();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_Beginner_Cmd))) == FlagRSP_Locale_Beginner_Cmd then
		FlagRSP:setRPFlag(4);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_Casual_Cmd))) == FlagRSP_Locale_Casual_Cmd then
		FlagRSP:setRPFlag(2);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_Normal_Cmd))) == FlagRSP_Locale_Normal_Cmd then
		FlagRSP:setRPFlag(1);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_Fulltime_Cmd))) == FlagRSP_Locale_Fulltime_Cmd then
		FlagRSP:setRPFlag(3);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_NoRP_Cmd))) == FlagRSP_Locale_NoRP_Cmd then
		FlagRSP:setRPFlag(0);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_OOC_Cmd))) == FlagRSP_Locale_OOC_Cmd then
		FlagRSP:setCharStatus(1);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_IC_Cmd))) == FlagRSP_Locale_IC_Cmd then
		FlagRSP:setCharStatus(2);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_ICFFA_Cmd))) == FlagRSP_Locale_ICFFA_Cmd then
		FlagRSP:setCharStatus(3);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_ST_Cmd))) == FlagRSP_Locale_ST_Cmd then
		FlagRSP:setCharStatus(4);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_NoCStatus_Cmd))) == FlagRSP_Locale_NoCStatus_Cmd then
		FlagRSP:setCharStatus(0);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_Status_Cmd))) == FlagRSP_Locale_Status_Cmd then
		FlagRSP:PlotStatus();
	elseif string.lower(msg) == "toggletooltip" then -- TODO Sinn?
		if ( FlagRSPConfigure:GetTooltipStyle() == "normal" ) then
			FlagRSPStatic:PrintM(FlagRSP_Locale_LightModifyTooltip);
			FlagRSPConfigure:SetTooltipStyle("light");
		elseif ( FlagRSPConfigure:GetTooltipStyle() == "light" ) then
			FlagRSPStatic:PrintM(FlagRSP_Locale_NoModifyTooltip);
			FlagRSPConfigure:SetTooltipStyle("none");
		elseif ( FlagRSPConfigure:GetTooltipStyle() == "none" ) then
			FlagRSPStatic:PrintM(FlagRSP_Locale_ModifyTooltip);
			FlagRSPConfigure:SetTooltipStyle("normal");
		end
        -- FlagRSP:UpdateTooltip();
	elseif string.lower(string.sub(msg, 1, string.len("purgeinterval"))) == "purgeinterval" then
		FlagRSP:PrintDebug("new purge interval: " .. string.sub(msg, string.len("purgeinterval")+2, string.len(msg)));
		if string.len(msg) > string.len("purgeinterval")+1 then
			local n = tonumber(string.sub(msg, string.len("purgeinterval")+2, string.len(msg)));
			if n ~= nil then
				FlagRSPSettings.FlagPurgeInterval = n*86400;
				FlagRSP:PrintDebug("new purge interval (set): " .. FlagRSPSettings.FlagPurgeInterval);
				local msg = string.gsub(FlagRSP_Locale_PurgeInterval, "%%s", n);
				FlagRSPStatic:PrintM(msg);
			end
		else
			local msg = string.gsub(FlagRSP_Locale_PurgeInterval, "%%s", math.floor(FlagRSPSettings.FlagPurgeInterval/86400*10)/10);
			FlagRSPStatic:PrintM(msg);
		end	
	elseif string.lower(msg) == "purge" then
		FlagHandler:PurgeAllFlags();
        FlagRSPProtocol:UpdateOwn();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_Surname_Cmd))) == FlagRSP_Locale_Surname_Cmd then -- TODO Rework
        FlagRSPStatic:PrintM("Set surname is out of order, sorry!");
		-- FlagRSP:setSurname(string.sub(msg, string.len(FlagRSP_Locale_Surname_Cmd)+2, string.len(msg)));
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_Firstname_Cmd))) ==  FlagRSP_Locale_Firstname_Cmd then -- TODO Rework
        FlagRSPStatic:PrintM("Set first name is out of order, sorry!");
		-- FlagRSP:SetName(string.sub(msg, string.len(FlagRSP_Locale_Firstname_Cmd)+2, string.len(msg)));
   
    elseif string.lower(string.sub(msg, 1, string.len("fullname"))) ==  "fullname" then 
		FlagRSP:setFullname((string.sub(msg, string.len("fullname")+2, string.len(msg))));
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_Title_Cmd))) == FlagRSP_Locale_Title_Cmd then
		FlagRSP:setTitle(string.sub(msg, string.len(FlagRSP_Locale_Title_Cmd)+2, string.len(msg)));
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	-- elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_AFK_Cmd))) == FlagRSP_Locale_AFK_Cmd then -- TODO Remove
        -- FlagRSPStatic:PrintM("FlagRSP-afk is out of order, sorry!");
		-- SendChatMessage(string.sub(msg, string.len(FlagRSP_Locale_AFK_Cmd)+2, string.len(msg)), "AFK");
	elseif string.lower(string.sub(msg, 1, string.len("edit"))) == "edit" then -- TODO Rework
        FlagRSPStatic:PrintM("Friendlist-command \"edit\" is out of order, sorry!");
		-- FRIENDLIST_ToggleGUI();
		-- Friendlist_TabHandler(2);
	elseif string.lower(string.sub(msg, 1, string.len("ingamename"))) == "ingamename" then -- TODO help entry
        if ( FlagRSPConfigure:GetShowUnitName() ) then
            FlagRSPConfigure:SetShowUnitName(false);
            FlagRSPStatic:PrintM("Hides the ingame name of the character.");
        else
            FlagRSPConfigure:SetShowUnitName(true);
            FlagRSPStatic:PrintM("Shows the ingame name of the character.");
        end
	elseif string.lower(string.sub(msg, 1, string.len("uinames"))) == "uinames" then
		FlagRSP:PrintDebug(GetCVar("UnitNamePlayer"));
		if GetCVar("UnitNameFriendlyPlayerName") == "1" then
			FlagRSPStatic:PrintM(FlagRSP_Locale_UINamesDisabled);
			SetCVar("UnitNameFriendlyPlayerName","0");
			SetCVar("UnitNameEnemyPlayerName","0");
		elseif GetCVar("UnitNameFriendlyPlayerName") == "0" then
			FlagRSPStatic:PrintM(FlagRSP_Locale_UINamesEnabled);
			SetCVar("UnitNameFriendlyPlayerName","1");
			SetCVar("UnitNameEnemyPlayerName","1");
		end
	elseif string.lower(string.sub(msg, 1, string.len("alwaysinfobox"))) == "alwaysinfobox" then
		if FlagRSPConfigure:GetAlwaysShowInfoBox() then
			FlagRSPStatic:PrintM(FlagRSP_Locale_InfoBoxTradBehaviour);
			FlagRSPConfigure:SetInfoBoxState(false);
		else
			FlagRSPStatic:PrintM(FlagRSP_Locale_AlwaysShowInfoBox);
			FlagRSPConfigure:SetInfoBoxState(true);
		end
	elseif string.lower(string.sub(msg, 1, string.len("resetbutton"))) == "resetbutton" then
		FlagRSPConfigure:SetInfoBoxButtonCoords(-1, -1);

	elseif string.lower(string.sub(msg, 1, 9)) == "debugsave" then
		if flagRSP_DebugSave then
			FlagRSPStatic:PrintM("Left debug saving mode.",1.0, 1.0, 0.0);
			flagRSP_DebugSave = false;
		else
			FlagRSPStatic:PrintM("Entered debug saving mode.",1.0, 1.0, 0.0);
			flagRSP_DebugSave = true;
		end
	elseif string.lower(string.sub(msg, 1, 5)) == "debug" then
		if flagRSP_Debug then
			FlagRSPStatic:PrintM("Left debug mode.",1.0, 1.0, 0.0);
			flagRSP_Debug = false;
		else
			FlagRSPStatic:PrintM("Entered debug mode.",1.0, 1.0, 0.0);
			flagRSP_Debug = true;
		end
	-- TODO: Add in Locale strings for these options.
	elseif ( string.lower(string.sub(msg, 1, string.len("coloredlevels"))) == "coloredlevels" ) then -- TODO Rework
        FlagRSPStatic:PrintM("Coloring levels is out of order, sorry!");
		-- if ( FlagRSPData.colorLevelText ) then
			-- FlagRSPData.colorLevelText = false;
			-- FlagRSPStatic:PrintM("colorLevelText set to false");
		-- else
			-- FlagRSPData.colorLevelText = true;
			-- FlagRSPStatic:PrintM("colorLevelText set to true");
		-- end
        -- FlagRSP:UpdateTooltip();
	elseif ( string.lower(string.sub(msg, 1, string.len("classcolor"))) == "classcolor" ) then
		if ( FlagRSPConfigure:GetClassColor() ) then
			FlagRSPConfigure:SetClassColor(false);
			FlagRSPStatic:PrintM("colorClassText set to false");
		else
			FlagRSPConfigure:SetClassColor(true);
			FlagRSPStatic:PrintM("colorClassText set to true");
		end
        -- FlagRSP:UpdateTooltip();
	elseif ( string.lower(string.sub(msg, 1, string.len("guildrank"))) == "guildrank" ) then
		if ( FlagRSPConfigure:GetGuildRank() ) then
			FlagRSPConfigure:SetGuildRank(false);
			FlagRSPStatic:PrintM("showGuildRank set to false");
		else
			FlagRSPConfigure:SetGuildRank(true);
			FlagRSPStatic:PrintM("showGuildRank set to true");
		end
	elseif ( string.lower(string.sub(msg, 1, string.len("resetinfobox"))) == "resetinfobox" ) then
		FlagRSPInfo:ResetPosition();
	else
		local t = 0;
		while FlagRSP_Locale_Help[t] ~= nil do
			DEFAULT_CHAT_FRAME:AddMessage(FlagRSP_Locale_Help[t],1.0, 1.0, 1.0);
			t = t + 1;
		end
	end
    
end


SLASH_RSPAN1 = "/rspan";
SLASH_RSPAN2 = "/rspon";
SlashCmdList["RSPAN"] = function () FlagRSP:enableRPTags(); end


SLASH_RSPAUS1 = "/rspaus";
SLASH_RSPAUS2 = "/rspoff";
SlashCmdList["RSPAUS"] = function () FlagRSP:disableRPTags(); end



SLASH_FRIENDLISTCOMMAND1 = "/fl";
SLASH_FRIENDLISTCOMMAND2 = "/friendlist";
SlashCmdList["FRIENDLISTCOMMAND"] = FRIENDLIST_SlashHandler;



SLASH_ADD1 = "/add";
SlashCmdList["ADD"] = addfriend_Msg;